#ifndef ImageManager_H_
#define ImageManager_H_

#include "GCTypes.h"
#include "ogc/gx.h"
#include <string>
#include <vector>

using namespace std;

class Image;

class ImageManager
{
public:

	~ImageManager();

	std::vector<Image*>::iterator ScanImagesFromSDCard();

	Image* GetImage(u32 ImageID);

	void DrawLineStrip(std::vector<Vtx> Container, u32 RGBAStart);
	void ReadDirForDataFiles(string Path, string LookFor);

	void StoreImage(string FullName);
	void StoreImage(u32 uWidth, u32 uHeight);
	void StoreImage(Image* pImage);
	virtual void StoreImage(u8* pTgaData, u32 Width , u32 Height);
	
	void CutImageIntoParts(string FullName, u32 CutSizeWidth, u32 CutSizeHeight, u32 uTotal = 0);

	vector<Image*>::iterator GetImageDataBegin();
	vector<Image*>::iterator GetImageDataEnd();

	//void Line(s16 x1, s16 y1, s16 x2, s16 y2, u32 RGBAStart, u32 RGBAEnd  );

	//void DrawFromImageData(u32* pImageData, f32 xpos, f32 ypos, u8 Alpha );
	int GetImageCount() const;

	void RemoveImages();
	void RefreshImages();



private:

	vector<Image*> m_ImageContainer;
};

#endif
