// Fridge Magnets for the wii - Paul Overy - 2010

// This code is one big fudge - I've frigged some code together from another game I'm working on, removing parts & hacking the rest.
// I've ended up with a rather large main file as I've been far to lazy to create or organise it into anything else.
// It's to be noted that the display side of things is far more frigged than the rest, 
// infact its a bit shit as the code was taken from a game in progress that was never intended for this kind of thing.
// So thats way most of the stuff outside main is not such a rush job.

#include <gccore.h>
#include <string.h>
#include "Singleton.h"
#include "WiiManager.h"
#include "Image.h"
#include "debug.h"
#include "ImageManager.h"
#include "InputDeviceManager.h"
#include "FontManager.h"
#include "WiiFile.h"
#include "EFB.h"


int  PowerOffMode(SYS_POWEROFF);  
bool bEnablePowerOffMode(false); 
void Trigger_Reset_Callback(void)			{ PowerOffMode = SYS_RESTART;  bEnablePowerOffMode=true; } 
void Trigger_Power_Callback(void)			{ PowerOffMode = SYS_POWEROFF; bEnablePowerOffMode=true; }  
void Trigger_PadPower_Callback( s32 chan )	{ PowerOffMode = SYS_POWEROFF; bEnablePowerOffMode=true; } 


class FridgeMagnet
{

public:

	FridgeMagnet(float x,float y, std::string Character)
	{
		Init();
		SetCharacter(Character);
		SetPos(x,y,0.0f);
	}

	float GetX() { return m_Pos.x; }
	float GetY() { return m_Pos.y; }
	float GetZ() { return m_Pos.z; }
	void SetZ( float value) { m_Pos.z=value; }
	void SetY( float value) { m_Pos.y=value; }
	void SetX( float value) { m_Pos.x=value; }
	guVector& GetPos() { return  m_Pos; }

	void SetPos(float x, float y, float z) { m_Pos.x = x; m_Pos.y = y; m_Pos.z = z; }
	void SetPos(guVector& Pos) { m_Pos = Pos; }

	float GetAngle() { return m_Angle; }
	FridgeMagnet* SetAngle(float Value) { m_Angle = Value;  return this;}

	float GetScale() { return m_Scale; }
	void SetScale(float Value) { m_Scale = Value; }

	void SetCharacter(std::string Char)			{ m_Character = Char; }
	std::string GetCharacter()	{ return m_Character; }

	void Display(float Scale, u8 Alpha)
	{
		WiiManager& Wii( Singleton<WiiManager>::GetInstanceByRef() );
		GXColor Col = GetColour();

		Wii.GetFontManager()->SetFontColour(0,0,0);
		Wii.GetFontManager()->GetFont()->DisplayTextScaled( GetCharacter(), 4,4,Scale,0xff);  // letter's shadow
		Wii.GetFontManager()->SetFontColour(Col.r,Col.g,Col.b);
		Wii.GetFontManager()->GetFont()->DisplayTextScaled( GetCharacter(), 0,0,Scale,Alpha);
	}

	FridgeMagnet* SetColour(u8 Red,u8 Green,u8 Blue, u8 Alpha) 
	{ 
		m_Colour.r=Red; m_Colour.g=Green, m_Colour.b=Blue; m_Colour.a= Alpha; 
		return this;
	}
	GXColor GetColour() { return m_Colour; }

	guVector  m_Velocity;

private:

	FridgeMagnet() { Init(); }

	void Init()
	{
		m_Character="";

		m_Pos.x=0;
		m_Pos.y=0;
		m_Pos.z=-500;

		m_Colour.a = 0xff;
		m_Colour.r = 0xf0;
		m_Colour.g = 0xf0;
		m_Colour.b = 0xf0;

		m_Angle = 0;

		m_Scale = 1.0f;

		m_Velocity.x=0;
		m_Velocity.y=0;
		m_Velocity.z=0;
	}

	guVector			m_Pos; 
	std::string			m_Character;
	GXColor				m_Colour;
	float				m_Angle;
	float				m_Scale;

};

class FridgeMagnetManager
{
public:

	FridgeMagnet* HitsFridgeMagnet(float x, float y, float area = 20.0f)
	{
		for (std::vector<FridgeMagnet*>::iterator iter(GetBegin()); iter!=GetEnd(); ++iter )
		{
			FridgeMagnet* pFridgeMagnet(*iter);
			if ((x>pFridgeMagnet->GetX()-area) && (x<pFridgeMagnet->GetX()+area) && 
				(y>pFridgeMagnet->GetY()-area) && (y<pFridgeMagnet->GetY()+area))
			{
				return pFridgeMagnet;
			}
		}
		return NULL;
	}

	FridgeMagnet* AddNewFridgeMagnet(float x, float y, std::string Character)
	{
		FridgeMagnet* pFridgeMagnet = new FridgeMagnet(x,y,Character);
		Add(pFridgeMagnet);
		return pFridgeMagnet;
	}

	void RemoveLastFridgeMagnet()
	{
		if (m_FridgeMagnetContainer.size()>1)
		{
			delete m_FridgeMagnetContainer.back();
			m_FridgeMagnetContainer.pop_back();
		}
	}

	void RemoveAllFridgeMagnets()
	{
		for (std::vector<FridgeMagnet*>::iterator iter(GetBegin()); iter!=GetEnd(); ++iter )
		{
			delete *iter;
		}
		m_FridgeMagnetContainer.clear();
	}

	void RemoveFridgeMagnet(FridgeMagnet* pFridgeMagnet)
	{
		for (std::vector<FridgeMagnet*>::iterator iter(GetBegin()); iter!=GetEnd(); ++iter )
		{
			if (pFridgeMagnet == *iter)
			{
				iter = m_FridgeMagnetContainer.erase(iter);
				break;
			}
		}
		delete pFridgeMagnet;
	}

	std::vector<FridgeMagnet*>::iterator GetBegin() { return m_FridgeMagnetContainer.begin(); }
	std::vector<FridgeMagnet*>::iterator GetEnd() { return m_FridgeMagnetContainer.end(); }
	
	std::map<char, GXColor> LetterColourContainer;

	void FridgeMagnetText(float x, float y, std::string Text, float WobbleFactor = 0.5, float Scale=1.0 )
	{
		float xpos(x);
		float ypos(y);
		for (std::string::iterator iter(Text.begin()); iter!=Text.end(); ++iter)
		{
			char Letter = *iter; //Characters.substr(i,1);

			u8 red = LetterColourContainer[ Letter ].r;
			u8 green = LetterColourContainer[ Letter ].g;
			u8 blue = LetterColourContainer[ Letter ].b;

			AddNewFridgeMagnet(xpos,ypos,&Letter)
				->SetColour(red,green,blue,0xff)
				->SetAngle( ( ( (float)rand()/RAND_MAX ) - 0.5f ) * WobbleFactor )
				->SetScale(Scale);

			xpos += 39.0f*Scale;
		}
	}
	
private:
	void Add(FridgeMagnet* pFridgeMagnet) {m_FridgeMagnetContainer.push_back(pFridgeMagnet); }

	std::vector<FridgeMagnet*> m_FridgeMagnetContainer;
};

GXColor Colour(u8 r,u8 g,u8 b,u8 a=0xff)
{
	GXColor Colour;
	Colour.a=a;
	Colour.b=b;
	Colour.g=g;
	Colour.r=r;
	return Colour;
}

float CameraFactor = 1.0f;  // this affects the camera height, the real 3D world width/height of the screen

int main(int argc, char **argv) 
{	
	WiiManager& Wii( Singleton<WiiManager>::GetInstanceByRef() );  // backbone stuff

	srand ( time(NULL) ); // we don't want the same random sequences each time we start.


	SYS_SetResetCallback(Trigger_Reset_Callback); 
    SYS_SetPowerCallback(Trigger_Power_Callback); 
	WPAD_SetPowerButtonCallback( Trigger_PadPower_Callback );
 
	//======================================================
	Wii.GetFontManager()->LoadFont("fonts/Bauhaus93-latin");	
	//======================================================

	// FOV set at 90 , giving a full left & right view. 
	// As the camera height is known the other 45deg length must be the same.
	// Note: Camera looks up to flip the view so it will work the same way as the 2d view.
	f32 CamX = (Wii.GetScreenWidth()/2) * CameraFactor;
	f32 CamY = (Wii.GetScreenHeight()/2) * CameraFactor;

	Mtx cameraMatrix, FinalMatrix,TransMatrix; 

	guVector camera = { CamX, CamY, -(Wii.GetScreenHeight()/2) * CameraFactor }; 
	guVector up =	{0.0F, -1.0F, 0.0F};  
	guVector look	= {CamX, CamY, 0.0F};
	guLookAt(cameraMatrix, &camera,	&up, &look);

//////////////		guMtxTransApply(TransMatrix,TransMatrix, pFridgeMagnet->GetX(), pFridgeMagnet->GetY(),pFridgeMagnet->GetZ());	// origin
//////////////		guMtxConcat(cameraMatrix,TransMatrix,FinalMatrix);
////////////   		GX_LoadPosMtxImm (cameraMatrix, GX_PNMTX0);  
////////////
////////////	Wii.GetFontManager()->SetFontColour(0xaa,0x22,0x11);
////////////	while ( Wii.GetInputDeviceManager()->IsWiiMoteReady(0) )
////////////	{
////////////		Wii.GetFontManager()->GetFont()->DisplayText("Waiting for wiiMote",140,200);
////////////		Wii.SwapScreen();
////////////	};
////////////



//================================================================================
// Setup Fridge magnets and 3d view

	FridgeMagnetManager  Manager;


	float StartAngle(0.0f);
	float PlacedAngle(0.0f);

	std::vector<GXColor> ColoursAvailable;
	ColoursAvailable.push_back(  Colour(179,88,165) ); //pink
	ColoursAvailable.push_back(  Colour( 75,180,75 ) ); //green
	ColoursAvailable.push_back(  Colour(104,89,158) ); //purple
	ColoursAvailable.push_back(  Colour(245,218,67) ); //yellow
	ColoursAvailable.push_back(  Colour(235,79,38 ) ); //orange
	ColoursAvailable.push_back(  Colour(41,161,240) ); //blue
	ColoursAvailable.push_back(  Colour(216,38,28 ) ); //red

	// starting letters
	std::string Characters = "eeeetttaaaoooiinnsshhrrdfllccuummwwffggyyppbbvvkkjxqzABCDEFGHIJKLMNOPQRSTUVWXYZ";

	for (u32 i=0; i<Characters.size();i++ )
	{
		std::string Letter = Characters.substr(i,1);
		if ( Manager.LetterColourContainer.find(*Letter.c_str()) == Manager.LetterColourContainer.end())
		{
			Manager.LetterColourContainer[ *Letter.c_str() ] = ColoursAvailable[i % (ColoursAvailable.size()) ];
		}
	}

	FridgeMagnet* pSelectedFridgeMagnet = NULL;
	FridgeMagnet* pLastSelectedFridgeMagnet = NULL;

	int ShowIntro=0;
	int ShowMainPart=0;

	CamX = (Wii.GetScreenWidth()/2) * CameraFactor;
	CamY = (Wii.GetScreenHeight()/2) * CameraFactor;


	do // Main loop
	{
		if ( bEnablePowerOffMode )
		{
			// one of the 'Trigger_...' funcs has been called
			// so we know the hardware IR triggered, go ahead on turn off.
			SYS_ResetSystem( PowerOffMode, 0, 0 );  
		}


		Wii.GetInputDeviceManager()->Store();
	
		guMtxIdentity(TransMatrix);  

		Vtx* pos(Wii.GetInputDeviceManager()->GetIRPosition());
		float xpos=0;
		float ypos=0;
		if (pos!=NULL)
		{
			
			xpos = (pos->x) + (CamX - ((Wii.GetScreenWidth()/2) * CameraFactor));
			ypos = (pos->y) + (CamY - ((Wii.GetScreenHeight()/2) * CameraFactor));

			static float ang=0.0;
			ang+=0.025;
			if (ang>M_PI*2)
				ang-=M_PI*2;


			guMtxRotRad(TransMatrix, 'Z',ang);
			guMtxTransApply(TransMatrix,TransMatrix,xpos,ypos,0);	// origin
			guMtxConcat(cameraMatrix,TransMatrix,FinalMatrix);
   			GX_LoadPosMtxImm (FinalMatrix, GX_PNMTX0);  

			Wii.GetFontManager()->SetFontColour(0xff,0x92,0x92);
			Wii.GetFontManager()->GetFont()->DisplayTextScaled("*",0,0,1.25f*CameraFactor);
		}



		u32 Pad (Wii.GetInputDeviceManager()->GetPadButton() );

		if (ShowIntro==0)
		{
			// show intro welcome

			Manager.FridgeMagnetText(60,100,"   WELCOME",1.0f);
			Manager.FridgeMagnetText(60,150,"     To",1.0f);
			Manager.FridgeMagnetText(60,200,"Fridge Magnets",1.0f);

			Manager.FridgeMagnetText(290,380,"by",0.5f,0.75f);
			Manager.FridgeMagnetText(290,420,"Paul Overy",0.5f,0.75f);

			ShowIntro=1;
		}
		else if ( (ShowIntro==60*2) || ( (Pad & WPAD_BUTTON_A) && (ShowMainPart==0) && (ShowIntro < (60*2)) ))
		{
			// fade out welcome

			for (std::vector<FridgeMagnet*>::iterator iter(Manager.GetBegin()); iter!=Manager.GetEnd(); ++iter)
			{
				FridgeMagnet* pFridgeMagnet(*iter);	
				pFridgeMagnet->m_Velocity.x=( (float)(rand()%100) - 50.0f )*0.1f;
				pFridgeMagnet->m_Velocity.y=( (float)(rand()%100) - 50.0f )*0.1f;
				pFridgeMagnet->m_Velocity.z=(-((rand()%50)+90))*0.1;
				pFridgeMagnet->SetAngle( ( ( (float)rand()/RAND_MAX ) - 0.5f ) * 0.5 );
			}
			ShowIntro = (60*2) + 1;
		}
		else if (((ShowMainPart==0) && (ShowIntro>200)) || ( (WPAD_ButtonsDown(0)&WPAD_BUTTON_A) && (ShowMainPart==0) && (ShowIntro<200) ) ) 
		{
			// zoom out a bit for main part

			CameraFactor = 1.25f;
			WPAD_SetVRes(WPAD_CHAN_ALL, Wii.GetGXRMode()->fbWidth* CameraFactor, Wii.GetGXRMode()->xfbHeight * CameraFactor);  // resolution of IR

			// clear all onscreen letters and add the new starting letters in random places.

			Manager.RemoveAllFridgeMagnets();

			for (u32 i=0; i<Characters.size(); /*nop*/ )
			{
				std::string Letter = Characters.substr(i,1);

				u8 red = Manager.LetterColourContainer[ *Letter.c_str() ].r;
				u8 green = Manager.LetterColourContainer[ *Letter.c_str() ].g;
				u8 blue = Manager.LetterColourContainer[ *Letter.c_str() ].b;

				float rx( (40*CameraFactor) + rand()%(int)((Wii.GetScreenWidth()-80) * CameraFactor));
				float ry( (40*CameraFactor) + rand()%(int)((Wii.GetScreenHeight()-80) * CameraFactor));
				if (Manager.HitsFridgeMagnet(rx,ry) == NULL)  // avoid overlapping letters
				{
					Manager.AddNewFridgeMagnet(rx,ry,Letter)
						->SetColour(red,green,blue,0xff)
						->SetAngle( ( (float)rand()/RAND_MAX ) - 0.5f)
						->SetZ(-500);
					++i;  // found an empty spot - now to the next letter
				}
			}
			ShowMainPart=1;
			CamX = (Wii.GetScreenWidth()/2) * CameraFactor;
			CamY = (Wii.GetScreenHeight()/2) * CameraFactor;
			ShowIntro = (200) + 1;
		}
		else if (ShowMainPart==0)
		{
			ShowIntro++;
		}


		if (WPAD_ButtonsDown(0)  & WPAD_BUTTON_2 ) 
		{
			for (std::vector<FridgeMagnet*>::iterator iter(Manager.GetBegin()); iter!=Manager.GetEnd(); ++iter)
			{
				FridgeMagnet* pFridgeMagnet(*iter);	
				float rx= (float)((rand()%1000)-500)*CameraFactor;
				float ry= (float)((rand()%1000)-500)*CameraFactor;
				pFridgeMagnet->m_Velocity.x = (float)((xpos-rx) - pFridgeMagnet->GetX())*0.01;
				pFridgeMagnet->m_Velocity.y = (float)((ypos-ry) - pFridgeMagnet->GetY())*0.01;
				pFridgeMagnet->m_Velocity.z = -3;
				pFridgeMagnet->SetZ(0);
			}
		}
		
		u32 Status;
		if (WPAD_Probe(0, &Status) == WPAD_ERR_NONE)  // check wiimote has not timed out/sleeping to save battery power
		{
			WPADData* pPadData2(WPAD_Data(0));
			int shake(((pPadData2->accel.x/100)+(pPadData2->accel.y/80)+(pPadData2->accel.z/80)));

			if (shake!=0)
			{
				//	ExitPrintf("%d",shake);  //debug
				if (shake < 10 || shake > 22)
				{
					for (std::vector<FridgeMagnet*>::iterator iter(Manager.GetBegin()); iter!=Manager.GetEnd(); ++iter)
					{
						FridgeMagnet* pFridgeMagnet(*iter);	
						pFridgeMagnet->m_Velocity.x=( (float)(rand()%1000) - 500.0f )*0.01f;
						pFridgeMagnet->m_Velocity.y=( (float)(rand()%1000) - 500.0f )*0.01f;
						pFridgeMagnet->m_Velocity.z=(-((rand()%20)+150))*0.1;
					}
				}
			}
		}

		if (WPAD_ButtonsDown(0) & WPAD_BUTTON_A) 
		{
			if (ShowIntro > 200)
			{
				// add a new letter - it will drop down from a height above the pointer.
				static int count(0);
				char a = 'a' + count;
				count = (count+1) % 26;
				std::string Letter = &(a);  //add 0 to 26
				u8 red = Manager.LetterColourContainer[ *Letter.c_str() ].r;
				u8 green = Manager.LetterColourContainer[ *Letter.c_str() ].g;
				u8 blue = Manager.LetterColourContainer[ *Letter.c_str() ].b;

				FridgeMagnet* pMag(Manager.AddNewFridgeMagnet(xpos,ypos,Letter));

				pMag->SetColour(red,green,blue,0xaf)
					->SetAngle( ( (float)rand()/RAND_MAX ) - 0.5f )
					->SetZ(-200);
				pMag->m_Velocity.z=0;
			}
		}

		if (WPAD_ButtonsDown(0) & WPAD_BUTTON_1) 
		{
			FridgeMagnet* pMag(Manager.HitsFridgeMagnet(xpos,ypos));
			if (pMag != NULL)
			{
				Manager.RemoveFridgeMagnet(pMag);
			}
		}

		if (Pad & WPAD_BUTTON_MINUS) 
		{
			CameraFactor+=0.01;
			if (CameraFactor>2.0f) CameraFactor=2.0f;
			WPAD_SetVRes(WPAD_CHAN_ALL, Wii.GetGXRMode()->fbWidth* CameraFactor, Wii.GetGXRMode()->xfbHeight * CameraFactor);  // resolution of IR
		}

		if (Pad & WPAD_BUTTON_PLUS) 
		{
			CameraFactor-=0.01;
			if (CameraFactor<0.5f) CameraFactor=0.5f;
			WPAD_SetVRes(WPAD_CHAN_ALL, Wii.GetGXRMode()->fbWidth* CameraFactor,Wii.GetGXRMode()->xfbHeight * CameraFactor);  // resolution of IR
		}

		if (Pad & WPAD_BUTTON_LEFT)
		{
			CamX -= 2;
		}
		if (Pad & WPAD_BUTTON_RIGHT)
		{
			CamX += 2;
		}
		if (Pad & WPAD_BUTTON_UP)
		{
			CamY -= 2;
		}
		if (Pad & WPAD_BUTTON_DOWN)
		{
			CamY += 2;
		}

		camera = { CamX, CamY, -(Wii.GetScreenHeight()/2) * CameraFactor }; 
		up =	{0.0F, -1.0F, 0.0F};  
		look	= {CamX, CamY, 0.0F};
		guLookAt(cameraMatrix, &camera,	&up, &look);


	
//===
		//guMtxIdentity(TransMatrix);  
		//guMtxConcat(cameraMatrix,TransMatrix,FinalMatrix);
  // 		GX_LoadPosMtxImm (FinalMatrix, GX_PNMTX0);  

		//Vtx* pVtx(Wii.GetInputDeviceManager()->GetIRPosition());
		//if (pVtx != NULL)
		//{
		//	Wii.GetImageManager()->DrawLineStrip(Wii.GetInputDeviceManager()->GetIRPositionContainer(),0xffffffff);
		//}

//===
		WPADData* pPadData(WPAD_Data(0));
		float RadAngle( (pPadData->orient.roll/180.0f)*M_PI ); // hardware in degrees, bit odd!
		u8 Alpha (0xff);

		int JustPickOne(0);
		for (std::vector<FridgeMagnet*>::iterator iter(Manager.GetBegin()); iter!=Manager.GetEnd(); ++iter)
		{
			FridgeMagnet* pFridgeMagnet(*iter);	
			guMtxIdentity(TransMatrix);  
			Alpha = 0xff;

			if ((pSelectedFridgeMagnet==NULL) && (xpos>pFridgeMagnet->GetX()-20) && (xpos<pFridgeMagnet->GetX()+20) && 
				(ypos>pFridgeMagnet->GetY()-20) && (ypos<pFridgeMagnet->GetY()+20))
			{
				if (pFridgeMagnet!=pLastSelectedFridgeMagnet && JustPickOne==0)
				{
					JustPickOne++;
					pFridgeMagnet->SetScale(2.2f);
					pLastSelectedFridgeMagnet = NULL;
				}

				if (Pad & WPAD_BUTTON_B)
				{
					StartAngle = RadAngle;
					pSelectedFridgeMagnet = pFridgeMagnet;
					PlacedAngle = pFridgeMagnet->GetAngle();
				}
			}
			else
			{
				if (pSelectedFridgeMagnet == pFridgeMagnet)
				{
					if (Pad & WPAD_BUTTON_B)
					{
						// Pick it up and move it
						pFridgeMagnet->SetScale(1.0f);
						pFridgeMagnet->SetPos(xpos,ypos,0);
						pFridgeMagnet->SetAngle(RadAngle - StartAngle + PlacedAngle);

						pLastSelectedFridgeMagnet = pSelectedFridgeMagnet;
					}
					else 
					{
						pLastSelectedFridgeMagnet = NULL;
						pSelectedFridgeMagnet = NULL;
						pFridgeMagnet->SetScale(1.0f);
					}
				}
			}

			guMtxRotRad(TransMatrix,'Z',pFridgeMagnet->GetAngle()); 

			pFridgeMagnet->SetZ(pFridgeMagnet->GetZ() + pFridgeMagnet->m_Velocity.z);
			pFridgeMagnet->SetY(pFridgeMagnet->GetY() + pFridgeMagnet->m_Velocity.y);
			pFridgeMagnet->SetX(pFridgeMagnet->GetX() + pFridgeMagnet->m_Velocity.x);

			if (ShowIntro > 60*2)
				pFridgeMagnet->m_Velocity.z+=0.65;

			if (ShowMainPart)
			{
				if (pFridgeMagnet->GetZ()>0.0f)
				{
					pFridgeMagnet->m_Velocity.x=(0.0f);
					pFridgeMagnet->m_Velocity.y=(0.0f);
					pFridgeMagnet->m_Velocity.z=(0.0f);
				}
			}

			float Scale = pFridgeMagnet->GetScale();
			Scale*=0.95f;
			if (Scale<1.0f) 
			{
				Scale=1.0f;
			}
			pFridgeMagnet->SetScale(Scale);

			guMtxTransApply(TransMatrix,TransMatrix,pFridgeMagnet->GetX(), pFridgeMagnet->GetY(),pFridgeMagnet->GetZ());	// origin
			guMtxConcat(cameraMatrix,TransMatrix,FinalMatrix);
   			GX_LoadPosMtxImm (FinalMatrix, GX_PNMTX0);  


			pFridgeMagnet->Display(pFridgeMagnet->GetScale(),Alpha);
		}



		Wii.SwapScreen();  // to clear zbuffer keep GX_SetZMode on until after this call 
	//	GX_SetZMode (GX_FALSE, GX_LEQUAL, GX_FALSE);


	} while( (WPAD_ButtonsUp(0) & WPAD_BUTTON_HOME)== 0 );


	return 0;
}